
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef MPC_controller_ERROR_H
#define MPC_controller_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_MPC_controller    (24569)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_MPC_controller_PCTRAJ_NOT_FOUND     H2_ENCODE_ERR(M_MPC_controller, 1)
#define S_MPC_controller_POM_NOT_FOUND        H2_ENCODE_ERR(M_MPC_controller, 2)
#define S_MPC_controller_SYS_UNDEFINED        H2_ENCODE_ERR(M_MPC_controller, 3)
#define S_MPC_controller_ALREADY_RUNNING      H2_ENCODE_ERR(M_MPC_controller, 4)
#define S_MPC_controller_POSTER_READ          H2_ENCODE_ERR(M_MPC_controller, 5)
#define S_MPC_controller_BLOCKED              H2_ENCODE_ERR(M_MPC_controller, 6)
#define S_MPC_controller_NO_PATH              H2_ENCODE_ERR(M_MPC_controller, 7)
#define S_MPC_controller_POSTER_NOT_FOUND     H2_ENCODE_ERR(M_MPC_controller, 8)


/* std errors */
#define S_MPC_controller_stdGenoM_ACTIVITY_INTERRUPTED       1610212353   /* 24569<<16 | 0x8000 | 100<<8 | 1 */
#define S_MPC_controller_stdGenoM_TOO_MANY_ACTIVITIES        1610212354   /* 24569<<16 | 0x8000 | 100<<8 | 2 */
#define S_MPC_controller_stdGenoM_ACTIVITY_FAILED            1610212355   /* 24569<<16 | 0x8000 | 100<<8 | 3 */
#define S_MPC_controller_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 1610212356   /* 24569<<16 | 0x8000 | 100<<8 | 4 */
#define S_MPC_controller_stdGenoM_UNKNOWN_ACTIVITY           1610212357   /* 24569<<16 | 0x8000 | 100<<8 | 5 */
#define S_MPC_controller_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 1610212358   /* 24569<<16 | 0x8000 | 100<<8 | 6 */
#define S_MPC_controller_stdGenoM_SYSTEM_ERROR               1610212359   /* 24569<<16 | 0x8000 | 100<<8 | 7 */
#define S_MPC_controller_stdGenoM_ACTIVITY_ALREADY_ENDED     1610212360   /* 24569<<16 | 0x8000 | 100<<8 | 8 */
#define S_MPC_controller_stdGenoM_WAIT_INIT_RQST             1610212361   /* 24569<<16 | 0x8000 | 100<<8 | 9 */
#define S_MPC_controller_stdGenoM_CONTROL_CODEL_ERROR        1610212362   /* 24569<<16 | 0x8000 | 100<<8 | 10 */
#define S_MPC_controller_stdGenoM_EXEC_TASK_SUSPENDED        1610212363   /* 24569<<16 | 0x8000 | 100<<8 | 11 */
#define S_MPC_controller_stdGenoM_BAD_BLOCK_TYPE             1610212364   /* 24569<<16 | 0x8000 | 100<<8 | 12 */
#define S_MPC_controller_stdGenoM_BAD_POSTER_TYPE            1610212365   /* 24569<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define MPC_CONTROLLER_H2_ERR_MSGS {\
    {"PCTRAJ_NOT_FOUND", 1},\
    {"POM_NOT_FOUND", 2},\
    {"SYS_UNDEFINED", 3},\
    {"ALREADY_RUNNING", 4},\
    {"POSTER_READ", 5},\
    {"BLOCKED", 6},\
    {"NO_PATH", 7},\
    {"POSTER_NOT_FOUND", 8},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int MPC_controllerRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
