
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_controller_POSTER_LIB_H
#define MPC_controller_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "MPC_controllerType.h"
#include "MPC_controllerError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[MPC_CONTROLLER_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} MPC_CONTROLLER_CNTRL_STR;

/* For consistency with other posters */
typedef MPC_CONTROLLER_CNTRL_STR MPC_CONTROLLER_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "MPC_controllerPosterLibStruct.h"



/* Posters */
#define MPC_CONTROLLER_CNTRL_POSTER_NAME genomInstanceSuffixName("MPC_controller", "Cntrl")
#define MPC_CONTROLLER_CTRL_POSTER_NAME genomInstanceSuffixName("MPC_controller", "Ctrl")
#define MPC_CONTROLLER_MODE_POSTER_NAME genomInstanceSuffixName("MPC_controller", "Mode")
#define MPC_CONTROLLER_PATHXY_POSTER_NAME genomInstanceSuffixName("MPC_controller", "PathXY")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS MPC_controllerPosterInit ( void );
extern POSTER_ID MPC_controllerCntrlPosterID ();
extern STATUS MPC_controllerCntrlPosterRead ( MPC_CONTROLLER_CNTRL_STR *MPC_controllerCntrlStrId );
extern STATUS MPC_controllerCntrlPosterInit ( void );
extern STATUS MPC_controllerCntrlInstancePosterRead(const char *name, MPC_CONTROLLER_CNTRL_STR *MPC_controllerCntrlStrId);
extern STATUS MPC_controllerCtrlPosterInit ( void );
extern POSTER_ID MPC_controllerCtrlPosterID ( void );
extern STATUS MPC_controllerCtrlPosterRead ( MPC_CONTROLLER_CTRL_POSTER_STR *x );
extern STATUS MPC_controllerCtrlInstancePosterRead ( const char *, MPC_CONTROLLER_CTRL_POSTER_STR * );
extern STATUS MPC_controllerCtrlctrl_sendPosterRead ( GENPOS_CART_SPEED *ctrl_send );
extern STATUS MPC_controllerCtrlctrl_sendInstancePosterRead( const char *, GENPOS_CART_SPEED * );
extern STATUS MPC_controllerModePosterInit ( void );
extern POSTER_ID MPC_controllerModePosterID ( void );
extern STATUS MPC_controllerModePosterRead ( MPC_CONTROLLER_MODE_POSTER_STR *x );
extern STATUS MPC_controllerModeInstancePosterRead ( const char *, MPC_CONTROLLER_MODE_POSTER_STR * );
extern STATUS MPC_controllerModemodePosterRead ( int *mode );
extern STATUS MPC_controllerModemodeInstancePosterRead( const char *, int * );
extern STATUS MPC_controllerPathXYPosterInit ( void );
extern POSTER_ID MPC_controllerPathXYPosterID ( void );
extern STATUS MPC_controllerPathXYPosterRead ( MPC_CONTROLLER_PATHXY_POSTER_STR *x );
extern STATUS MPC_controllerPathXYInstancePosterRead ( const char *, MPC_CONTROLLER_PATHXY_POSTER_STR * );
extern STATUS MPC_controllerPathXYpathXYPosterRead ( PL_PATH_XY *pathXY );
extern STATUS MPC_controllerPathXYpathXYInstancePosterRead( const char *, PL_PATH_XY * );
#ifdef __cplusplus
}
#endif
#endif

