
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * Sara Fleury
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_CONTROLLER_PRINTXML_H
#define MPC_CONTROLLER_PRINTXML_H

#include "genom/printScan.h"
#include "genom/printXMLProto.h"

/* Structures definies par d'autres modules */

#include "server/MPC_avoidObsPrintXML.h"

#include "server/MPC_plannerPrintXML.h"

#include "server/dtmPrintXML.h"

#include "server/pomPrintXML.h"

#include "server/genPosPrintXML.h"


#include "MPC_controllerPosterLib.h"

/* Prototypes */
extern void printXML_struct_MPC_CONTROLLER_PATHXY_POSTER_STR ( FILE *out, char *name,
     struct MPC_CONTROLLER_PATHXY_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_CONTROLLER_MODE_POSTER_STR ( FILE *out, char *name,
     struct MPC_CONTROLLER_MODE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_CONTROLLER_CTRL_POSTER_STR ( FILE *out, char *name,
     struct MPC_CONTROLLER_CTRL_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_CTRLER_STR ( FILE *out, char *name,
     struct MPC_CTRLER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_TRACKCTRAJ_I ( FILE *out, char *name,
     struct TRACKCTRAJ_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SETMANASYS_I ( FILE *out, char *name,
     struct SETMANASYS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_GOTO_I ( FILE *out, char *name,
     struct GOTO_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_INIT_I ( FILE *out, char *name,
     struct INIT_I *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void printXML_INIT_I ( FILE *out, char *name,
     INIT_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_GOTO_I ( FILE *out, char *name,
     GOTO_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SETMANASYS_I ( FILE *out, char *name,
     SETMANASYS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_TRACKCTRAJ_I ( FILE *out, char *name,
     TRACKCTRAJ_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_CTRLER_STR ( FILE *out, char *name,
     MPC_CTRLER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_CONTROLLER_CTRL_POSTER_STR ( FILE *out, char *name,
     MPC_CONTROLLER_CTRL_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_CONTROLLER_MODE_POSTER_STR ( FILE *out, char *name,
     MPC_CONTROLLER_MODE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_CONTROLLER_PATHXY_POSTER_STR ( FILE *out, char *name,
     MPC_CONTROLLER_PATHXY_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );

#endif /* MPC_CONTROLLER_PRINT_XML_H */

