
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

/* 
 * MPC_controllerType.h:     La SDI_F de MPC_controller
 *
 * Utilise par le module et par les clients
 * (inclut dans MPC_controllerMsgLib.h et MPC_controllerPosterLib.h)
 * 
 */

#ifndef MPC_controller_TYPE_H
#define MPC_controller_TYPE_H

#include "genom/modules.h"
#include "MPC_controllerError.h"

/* Nombre de tache d'execution de ce module */
#define MPC_CONTROLLER_NB_EXEC_TASK                   (1)


#endif
#ifndef MPC_controller_TYPE1_H
#define MPC_controller_TYPE1_H

#include "/opt/openrobots/include/genPos/genPosStruct.h"
#include "/opt/openrobots/include/pom/pomStruct.h"
#include "/opt/openrobots/include/dtm/dtmStruct.h"
#include "/opt/openrobots/include/MPC/gen-structs/structs_gen.h"
#include "/opt/openrobots/include/MPC_planner/MPC_planner-Struct.h"
#include "/opt/openrobots/include/MPC_avoidObs/MPC_avoidObs-Struct.h"
#include "MPC_controller-Struct.h"

/*
 * Structure de donnees interne
 */
typedef struct MPC_CTRLER_STR {
	int system_type;
	PL_PATH_XY pathXY;
	GENPOS_CART_CONFIG goal_pos;
	GENPOS_CART_SPEED ctrl_send;
	int mode;
	MANA_PCTRAJ ctraj;
	float ctraj_eval_time;
	INIT_I Init_I;
	GOTO_I Goto_I;
	SETMANASYS_I SetManaSys_I;
	TRACKCTRAJ_I TrackCTraj_I;
	float TimeHorizon_I;
	TAB_CAND_PATH tabCandPath;
	PL_PATH_XY bestPath;
} MPC_CTRLER_STR;


#endif

