
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_controller_TCLSERV_CLIENT_MSG_LIB_H
#define MPC_controller_TCLSERV_CLIENT_MSG_LIB_H

#include <server/MPC_controllerType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int MPC_controllerTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int MPC_controllerTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int MPC_controllerTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 INIT_I *(in_Init_I) 
		);

int MPC_controllerTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_controllerTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				INIT_I *(in_Init_I) ,
				
				int *bilan);

int MPC_controllerTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					INIT_I *(in_Init_I) ,
					
					int *bilan);




int MPC_controllerTclservClientGoToRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GOTO_I *(in_Goto_I) 
		);

int MPC_controllerTclservClientGoToReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_controllerTclservClientGoToRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GOTO_I *(in_Goto_I) ,
				
				int *bilan);

int MPC_controllerTclservClientGoToRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GOTO_I *(in_Goto_I) ,
					
					int *bilan);




int MPC_controllerTclservClientSetManaSysRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SETMANASYS_I *(in_SetManaSys_I) 
		);

int MPC_controllerTclservClientSetManaSysReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_controllerTclservClientSetManaSysRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SETMANASYS_I *(in_SetManaSys_I) ,
				
				int *bilan);

int MPC_controllerTclservClientSetManaSysRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SETMANASYS_I *(in_SetManaSys_I) ,
					
					int *bilan);




int MPC_controllerTclservClientStopRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int MPC_controllerTclservClientStopReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_controllerTclservClientStopRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int MPC_controllerTclservClientStopRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int MPC_controllerTclservClientTrackCTrajRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 TRACKCTRAJ_I *(in_TrackCTraj_I) 
		);

int MPC_controllerTclservClientTrackCTrajReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_controllerTclservClientTrackCTrajRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				TRACKCTRAJ_I *(in_TrackCTraj_I) ,
				
				int *bilan);

int MPC_controllerTclservClientTrackCTrajRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					TRACKCTRAJ_I *(in_TrackCTraj_I) ,
					
					int *bilan);




int MPC_controllerTclservClientStopCTrajTrackRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int MPC_controllerTclservClientStopCTrajTrackReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_controllerTclservClientStopCTrajTrackRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* MPC_controllerTCLSERV_CLIENT_MSG_LIB_H */

