
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] MPC_controllerInstall] >= 0 } {
    interp expose {} MPC_controllerInstall
}

proc ::MPC_controllerInstall { name } {
    foreach rqst { "Init" "GoTo" "SetManaSys" "Stop" "TrackCTraj" "StopCTrajTrack" "Ctrlctrl_sendPosterRead" "ModemodePosterRead" "PathXYpathXYPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} MPC_controller$rqst $name
    }
}

interp hide {} MPC_controllerInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_controllerInit] >= 0 } {
    interp expose {} MPC_controllerInit
}
if { [lsearch [interp hidden] MPC_controllerInitFormatOutput] >= 0 } {
    interp expose {} MPC_controllerInitFormatOutput
}

proc ::MPC_controllerInit { name args } {
    set format {}
    lappend format [list string "Init_I.pomPoster" "" ]
    lappend format [list string "Init_I.demPoster" "" ]
    lappend format [list string "Init_I.strajPoster" "" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Initializes the MPC controller module" \
	"INIT_I\n| char pomPoster\[256\]\n| char demPoster\[256\]\n| char strajPoster\[256\]\n" \
	3 \
	$format \
	$args ]
}


proc ::MPC_controllerInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_controllerInit
interp hide {} MPC_controllerInitFormatOutput





# GoTo ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_controllerGoTo] >= 0 } {
    interp expose {} MPC_controllerGoTo
}
if { [lsearch [interp hidden] MPC_controllerGoToFormatOutput] >= 0 } {
    interp expose {} MPC_controllerGoToFormatOutput
}

proc ::MPC_controllerGoTo { name args } {
    set format {}
    lappend format [list double "X coordinate" 0.000000 ]
    lappend format [list double "Y coordinate" 0.000000 ]
    lappend format [list double "Goto_I.goal.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "GoTo" \
	"Goto process without obstacle avoidance" \
	"GOTO_I\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n" \
	3 \
	$format \
	$args ]
}


proc ::MPC_controllerGoToFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_controllerGoTo
interp hide {} MPC_controllerGoToFormatOutput





# SetManaSys ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_controllerSetManaSys] >= 0 } {
    interp expose {} MPC_controllerSetManaSys
}
if { [lsearch [interp hidden] MPC_controllerSetManaSysFormatOutput] >= 0 } {
    interp expose {} MPC_controllerSetManaSysFormatOutput
}

proc ::MPC_controllerSetManaSys { name args } {
    set format {}
    lappend format [list double "SetManaSys_I.body_length" 0.0 ]
    lappend format [list double "SetManaSys_I.body_width" 0.0 ]
    lappend format [list double "SetManaSys_I.body_z" 0.0 ]
    lappend format [list double "SetManaSys_I.ground_clearance" 0.0 ]
    lappend format [list double "SetManaSys_I.rollMax" 0.0 ]
    lappend format [list double "SetManaSys_I.pitchMax" 0.0 ]
    lappend format [list double "SetManaSys_I.vmin" 0.0 ]
    lappend format [list double "SetManaSys_I.vmax" 0.0 ]
    lappend format [list double "SetManaSys_I.accel" 0.0 ]
    lappend format [list double "SetManaSys_I.decel" 0.0 ]
    lappend format [list double "SetManaSys_I.wmax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetManaSys" \
	"Change Mana geometry and system constraints" \
	"SETMANASYS_I\n| double body_length\n| double body_width\n| double body_z\n| double ground_clearance\n| double rollMax\n| double pitchMax\n| double vmin\n| double vmax\n| double accel\n| double decel\n| double wmax\n" \
	11 \
	$format \
	$args ]
}


proc ::MPC_controllerSetManaSysFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_controllerSetManaSys
interp hide {} MPC_controllerSetManaSysFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_controllerStop] >= 0 } {
    interp expose {} MPC_controllerStop
}
if { [lsearch [interp hidden] MPC_controllerStopFormatOutput] >= 0 } {
    interp expose {} MPC_controllerStopFormatOutput
}

proc ::MPC_controllerStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stops the controller process" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_controllerStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_controllerStop
interp hide {} MPC_controllerStopFormatOutput





# TrackCTraj ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_controllerTrackCTraj] >= 0 } {
    interp expose {} MPC_controllerTrackCTraj
}
if { [lsearch [interp hidden] MPC_controllerTrackCTrajFormatOutput] >= 0 } {
    interp expose {} MPC_controllerTrackCTrajFormatOutput
}

proc ::MPC_controllerTrackCTraj { name args } {
    set format {}
    lappend format [list string "Mana control trajectory poster name" 0 ]
    lappend format [list float "TrackCTraj_I.ctraj_eval_time" 0.0 ]

    return [ ::cs::rqstSend "${name}" "TrackCTraj" \
	"Starts the control trajectory tracking" \
	"TRACKCTRAJ_I\n| char ctrajPoster\[256\]\n| float ctraj_eval_time\n" \
	2 \
	$format \
	$args ]
}


proc ::MPC_controllerTrackCTrajFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_controllerTrackCTraj
interp hide {} MPC_controllerTrackCTrajFormatOutput





# StopCTrajTrack ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_controllerStopCTrajTrack] >= 0 } {
    interp expose {} MPC_controllerStopCTrajTrack
}
if { [lsearch [interp hidden] MPC_controllerStopCTrajTrackFormatOutput] >= 0 } {
    interp expose {} MPC_controllerStopCTrajTrackFormatOutput
}

proc ::MPC_controllerStopCTrajTrack { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopCTrajTrack" \
	"Stops the control trajectory tracking" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_controllerStopCTrajTrackFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_controllerStopCTrajTrack
interp hide {} MPC_controllerStopCTrajTrackFormatOutput





# Ctrlctrl_send ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_controllerCtrlctrl_sendPosterRead] >= 0 } {
    interp expose {} MPC_controllerCtrlctrl_sendPosterRead
}
if { [lsearch [interp hidden] MPC_controllerCtrlctrl_sendPosterFormatOutput] >= 0 } {
    interp expose {} MPC_controllerCtrlctrl_sendPosterFormatOutput
}

proc ::MPC_controllerCtrlctrl_sendPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Ctrlctrl_send" \
	"GENPOS_CART_SPEED\n| int numRef\n| int updatePeriod\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::MPC_controllerCtrlctrl_sendPosterFormatOutput { list } {
    set format { {} status { } { ctrl_send { } numRef { } updatePeriod { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_controllerCtrlctrl_sendPosterRead
interp hide {} MPC_controllerCtrlctrl_sendPosterFormatOutput





# Modemode ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_controllerModemodePosterRead] >= 0 } {
    interp expose {} MPC_controllerModemodePosterRead
}
if { [lsearch [interp hidden] MPC_controllerModemodePosterFormatOutput] >= 0 } {
    interp expose {} MPC_controllerModemodePosterFormatOutput
}

proc ::MPC_controllerModemodePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Modemode" \
	"int mode\n" \
	$args ]
}


proc ::MPC_controllerModemodePosterFormatOutput { list } {
    set format { {} status { } mode }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_controllerModemodePosterRead
interp hide {} MPC_controllerModemodePosterFormatOutput





# PathXYpathXY ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_controllerPathXYpathXYPosterRead] >= 0 } {
    interp expose {} MPC_controllerPathXYpathXYPosterRead
}
if { [lsearch [interp hidden] MPC_controllerPathXYpathXYPosterFormatOutput] >= 0 } {
    interp expose {} MPC_controllerPathXYpathXYPosterFormatOutput
}

proc ::MPC_controllerPathXYpathXYPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "PathXYpathXY" \
	"PL_PATH_XY\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n| int nbPos\n" \
	$args ]
}


proc ::MPC_controllerPathXYpathXYPosterFormatOutput { list } {
    set format { {} status { } { pathXY { 5000 } { tab { } x { } y { } theta } { } nbPos } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_controllerPathXYpathXYPosterRead
interp hide {} MPC_controllerPathXYpathXYPosterFormatOutput


